/* Lego.inc: fichier contenant tous les objets lego technics.

   Fichier cr par Benjamin Bellire le 6/10/97

	For the English users, sorry for the french terms but it's very simple
to understand... And for one time YOU do the effort. :-)

*/

#declare e1=<7.6,0,0>   // Ce qu'il y a de gnial avec Povray, c'est qu'on peut dfinir des
#declare e2=<0,0,7.6>   // vecteurs e1, e2, e3 comme tants les 3 coordonnes de base des lgos.
#declare e3=<0,9.5,0>   // ces vecteurs ne servent que pour les blocs.
#declare lego_yellow=rgb<1.1,1,0>
#declare lego_blue=rgb<0,0,0.6>

#declare lego_black =
texture {
  pigment { color red 0.1 green 0.1 blue 0.1 }
  finish { ambient .1 phong 0.75 phong_size 75 reflection .2 }
}


#declare tourneY=transform { rotate -90*y translate e1 }


// Les trous dans les barres

#declare trou_tige=union { cylinder {
  e1+0.6*e3-e2,e1+0.6*e3+2*e2,2.5 } // fin du grand cylindre
  cylinder { // voici les 2 petits qui pauffinent le tout...
  e1+0.6*e3+1.1*e2, e1+0.6*e3+0.9*e2,3 }
  cylinder {
  e1+0.6*e3-0.1*e2,e1+0.6*e3+0.1*e2,3 }
} //fin de l'union

// Les tetons des barres

#if (Detail_level=2)
 #declare teton=difference { // grand cylindre moins petit.
 cylinder {e3+1/2*(e1+e2),1.2*e3+1/2*(e1+e2),2.35 } //grand cylindre ...
 cylinder {e3+1/2*(e1+e2),1.5*e3+1/2*(e1+e2),1.5 } //moins petit.
 }
#else
 #declare teton=box {<0,0,0> <1,1,1> }
#end


#declare teton_normal=cylinder {e3+1/2*(e1+e2),1.2*e3+1/2*(e1+e2),2.35 }

#declare barre_2_biseaute=union {
object {teton_normal}
difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
           box { -0.7*e1-e2-e3 0.7*e1+2*e2+e3 rotate <0,0,-45> translate 2.4*e1+1.3*e3 }
 }
}

#declare barre_3_biseaute=union {
object {teton_normal}
difference { superellipsoid { <0.05,0.05> scale 0.5*(3*e1+e2+e3) translate 0.5*(3*e1+e2+e3)  }
           box { -0.7*e1-e2-e3 0.7*e1+2*e2+3*e3 rotate <0,0,65> translate 2.4*e1+1.12*e3 }
 }
}

#declare barre_3_biseaute_inverse=union {
object {teton_normal}
object {teton translate e1}
object {teton translate 2*e1}
difference { superellipsoid { <0.05,0.05> scale 0.5*(3*e1+e2+e3) translate 0.5*(3*e1+e2+e3)  }
           box { -0.7*e1-e2-e3 0.7*e1+2*e2+3*e3 rotate <0,0,-65> translate 2.4*e1 }
 }
}

#declare barre_2_biseaute_inverse=union {
object {teton}
object {teton translate e1}
difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
           box { -0.7*e1-e2-e3 0.7*e1+2*e2+e3 rotate <0,0,45> translate 2.4*e1-0.3*e3 }
 }
}

#declare barre_2=union {
object {teton}
object {teton translate e1}
difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
trou_tige }
}

#declare barre_22=union {
object {teton}
object {teton translate e1}
difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
union { object { trou_tige translate -0.45*e1}
        object { trou_tige translate 0.45*e1}
}
} }

#declare barre_4=union {
 #declare Count=0
  #while (Count < 4)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference {difference {difference { superellipsoid { <0.05,0.05> scale 0.5*(4*e1+e2+e3) translate 0.5*(4*e1+e2+e3)  }
                       object { trou_tige }
           }
           object {trou_tige translate e1}
}
object {trou_tige translate 2*e1} }
}

#declare barre_6=union {
 #declare Count=0
  #while (Count < 6)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(6*e1+e2+e3) translate 0.5*(6*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 5)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare barre_8=union {
 #declare Count=0
  #while (Count < 8)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(8*e1+e2+e3) translate 0.5*(8*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 7)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare barre_10=union {
 #declare Count=0
  #while (Count < 10)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(10*e1+e2+e3) translate 0.5*(10*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 9)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare barre_12=union {
 #declare Count=0
  #while (Count < 12)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(12*e1+e2+e3) translate 0.5*(12*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 11)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare barre_16=union {
 #declare Count=0
  #while (Count < 16)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(16*e1+e2+e3) translate 0.5*(16*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 15)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare barre_17=union {
 #declare Count=0
  #while (Count < 17)
    object {teton translate Count*e1}
    #declare Count=Count+1
  #end
difference { superellipsoid { <0.05,0.05> scale 0.5*(17*e1+e2+e3) translate 0.5*(17*e1+e2+e3)  }
             union {
 #declare Count=0
  #while (Count < 16)
    object { trou_tige translate Count*e1}
    #declare Count=Count+1
  #end
}}}

#declare tige_2=union {superellipsoid { <0.05, 0.05> scale e1+<0,2,0.8> translate e1 }
                       superellipsoid { <0.05, 0.05> scale e1+<0,2,0.8> translate e1 rotate 90*x}
texture { lego_black }
               }
#declare tige_3=union {superellipsoid { <0.05, 0.05> scale 1.5*e1+<0,2,0.8> translate 1.5*e1 }
                       superellipsoid { <0.05, 0.05> scale 1.5*e1+<0,2,0.8> translate 1.5*e1 rotate 90*x}
texture {lego_black}
               }
#declare tige_4=union {superellipsoid { <0.05, 0.05> scale 2*e1+<0,2,0.8> translate 2*e1 }
                       superellipsoid { <0.05, 0.05> scale 2*e1+<0,2,0.8> translate 2*e1 rotate 90*x}
texture {lego_black}
               }
#declare tige_6=union {superellipsoid { <0.05, 0.05> scale 3*e1+<0,2,0.8> translate 3*e1 }
                       superellipsoid { <0.05, 0.05> scale 3*e1+<0,2,0.8> translate 3*e1 rotate 90*x}
texture {lego_black}
               }
#declare tige_8=union {superellipsoid { <0.05, 0.05> scale 4*e1+<0,2,0.8> translate 4*e1 }
                       superellipsoid { <0.05, 0.05> scale 4*e1+<0,2,0.8> translate 4*e1 rotate 90*x}
texture {lego_black}
               }
#declare tige_10=union {superellipsoid { <0.05, 0.05> scale 5*e1+<0,2,0.8> translate 5*e1 }
                       superellipsoid { <0.05, 0.05> scale 5*e1+<0,2,0.8> translate 5*e1 rotate 90*x}
texture {lego_black}
               }
#declare tige_12=union {superellipsoid { <0.05, 0.05> scale 6*e1+<0,2,0.8> translate 6*e1 }
                       superellipsoid { <0.05, 0.05> scale 6*e1+<0,2,0.8> translate 6*e1 rotate 90*x}
texture {lego_black}
               }

// plaques
#declare plaque_2x1_milieu=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+1/3*e3) translate 0.5*(2*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                               object {teton translate -2/3*e3+0.5*e1 }
                          }

#declare plaque_1x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(e1+e2+1/3*e3) translate 0.5*(e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,0.9*(e1+e2)+0.26*e3 }
                                       }
                            object { teton_normal translate -2/3*e3 }
                          }
#declare plaque_2x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+1/3*e3) translate 0.5*(2*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 2)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_3x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(3*e1+e2+1/3*e3) translate 0.5*(3*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,2.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 3)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_4x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(4*e1+e2+1/3*e3) translate 0.5*(4*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,3.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_6x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(6*e1+e2+1/3*e3) translate 0.5*(6*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,5.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 6)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_8x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(8*e1+e2+1/3*e3) translate 0.5*(8*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,7.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_10x1=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(10*e1+e2+1/3*e3) translate 0.5*(10*e1+e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,9.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 10)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }

#declare plaque_2x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(2*e1+2*e2+1/3*e3) translate 0.5*(2*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 2)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 2)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_3x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(3*e1+2*e2+1/3*e3) translate 0.5*(3*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 3)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 3)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }

#declare plaque_4x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(4*e1+2*e2+1/3*e3) translate 0.5*(4*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_6x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(6*e1+2*e2+1/3*e3) translate 0.5*(6*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 6)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 6)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_8x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(8*e1+2*e2+1/3*e3) translate 0.5*(8*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }
#declare plaque_10x2=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(10*e1+2*e2+1/3*e3) translate 0.5*(10*e1+2*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 10)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 10)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }

#declare plaque_8x4=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(8*e1+4*e2+1/3*e3) translate 0.5*(8*e1+4*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+2*e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 8)
                               object {teton_normal translate -2/3*e3+3*e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }

#declare plaque_4x4=union { difference { superellipsoid { <0.05,0.05> scale 0.5*(4*e1+4*e2+1/3*e3) translate 0.5*(4*e1+4*e2+1/3*e3)  }
                                         box {0.1*(e1+e2)-e3,1.9*e1+0.9*e2+0.26*e3 }
                                       }
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+2*e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                            #declare Count=0
                              #while (Count < 4)
                               object {teton_normal translate -2/3*e3+3*e2+Count*e1 }
                               #declare Count=Count+1
                              #end
                          }

#declare tenon_blanc=difference{difference{
difference {union {cylinder{ <0,0,0>,2*e1,2.5 texture {pigment{color Gray90 }} }
                                       cylinder{ 0.9*e1,1.1*e1,3 texture {pigment{color Gray90 }}}
                                      }
                                cylinder {-e1,3*e1,2.4 texture {pigment{color Gray90 }}}
                               } box {-e1-<0,4,0.4>,1/2*e1+<0,4,0.4> pigment {color Gray90}}
                               } box {3*e1-<0,4,0.4>,3/2*e1+<0,4,0.4> pigment {color Gray90}}
                               }

#declare tenon_noir=difference{difference{difference{
difference {union {cylinder{ <0,0,0>,2*e1,2.5 texture { lego_black}  }
                                       cylinder{ 0.9*e1,1.1*e1,3 texture { lego_black }}
                                      }
                                cylinder {-e1,3*e1,2.4 texture { lego_black}}
                               } box {-e1-<0,4,0.4>,1/2*e1+<0,4,0.4> texture {lego_black}}
                               } box {3*e1-<0,4,0.4>,3/2*e1+<0,4,0.4> texture {lego_black}}
                               } box {1/2*e1-<0,0.4,5>,3/2*e1+<0,0.4,5> texture {lego_black}} }

#declare double_tenon_noir=difference {union { cylinder {<0,0,0> 3*e1 2.5 texture {lego_black}}
                          cylinder {0.9*e1 1.1*e1 3 texture {lego_black}}
                          cylinder {1.9*e1 2.1*e1 2.7 texture {lego_black}}
                          }
                          union {cylinder {-e1 4*e1 2.4 texture {lego_black}}
                                 box {-e1-<0,4,0.4> 1/2*e1+<0,4,0.4> texture {lego_black}}
                                 box {4*e1-<0,4,0.4> 5/2*e1+<0,4,0.4> texture {lego_black}}
                                 box {1/2*e1-<0,0.4,5>,1.3*e1+<0,0.4,5> texture {lego_black}}
                                 box {1.7*e1-<0,0.4,5>,5/2*e1+<0,0.4,5> texture {lego_black}}
                                }
                          }

#declare bague=difference{difference{difference{union{cylinder{<0,0,0>,e1,2.9 texture{pigment{color Gray90}}} cylinder {<0,0,0>,0.1*e1,3.5 texture{pigment{color Gray90}}}
                     cylinder {e1,0.9*e1,3.5 texture{pigment{color Gray90}}}
} box {0.1*e1-e3-0.1*e2,0.9*e1+2*e3+0.1*e2 texture{pigment{color Gray90}}}
} object{ tige_2 translate -1/2*e1 }
} union { /*les 4 petits cylindres*/
          cylinder {1/2*(e1+e2+e3),2*e1+1/2*(e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(e1-e2+e3),2*e1+1/2*(-e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(e1-e2-e3),2*e1-1/2*(e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(e1+e2-e3),2*e1+1/2*(e2-e3),3 texture {pigment{color Gray90}}}
}
}

// Engrenages
// ****************************************

#declare wide =   0.8
#declare stud_radius= 0.24
#declare tech_hole_inner_rad= stud_radius
#declare tech_hole_outer_rad= (stud_radius+0.02)
#declare tech_axle_height= 0.08
#declare tech_axle_width= (tech_hole_inner_rad - 0.02)
#declare flat = 0.32
#declare wall = 0.125
#declare stud_height= 0.16
#declare thin_flat_column =
 cylinder { <0, (flat-wall),0>, <0, 0, 0>, stud_height }

#declare tech_gear_tooth =
intersection
 {
  box {<-0.075, 0, (-0.25*wide)>, <0.075, (wide-(2*tech_hole_outer_rad)), (0.25*wide)> }
  sphere {  <0, 0, 0>, 1 scale <0.075, ((wide-(2*tech_hole_outer_rad))), 1000> }
 }

#declare tech_gear_8_tooth =
object {tech_gear_tooth translate <0, (tech_hole_outer_rad), 0> }

#declare tech_gear_8_teeth =
union
 {
  #declare number=8
  #declare current=0
  #while (current < 360)
   object { tech_gear_8_tooth rotate <0,0,current> }
   #declare current = current + (360/number)
  #end
 }

#declare tech_gear_24_tooth =
object {tech_gear_tooth translate <0, (tech_hole_outer_rad+wide), 0> }

#declare tech_gear_24_teeth =
union
 {
  #declare number=24
  #declare current=0
  #while (current < 360)
   object { tech_gear_24_tooth rotate <0,0,current> }
   #declare current = current + (360/number)
  #end
}

#declare tech_gear_40_tooth =
 object {tech_gear_tooth translate <0, (tech_hole_outer_rad+(2*wide)), 0> }

#declare tech_gear_40_teeth =
union
 {
  #declare number=40
  #declare current=0
  #while (current < 360)
   object { tech_gear_40_tooth rotate <0,0,current> }
   #declare current = current + (360/number)
  #end
}

#declare tech_axle =
union
 {
  box {<(-1*tech_axle_height), (-1*tech_axle_width), 0>, <(tech_axle_height), (tech_axle_width), wide> }
  box {<(-1*tech_axle_width), (-1*tech_axle_height), 0>, <(tech_axle_width), (tech_axle_height), wide> }
 }

#declare l3g0_tech_axle_2 = object { tech_axle scale <1,1,2> }
#declare l3g0_tech_axle_3 = object { tech_axle scale <1,1,3> }
#declare l3g0_tech_axle_4 = object { tech_axle scale <1,1,4> }
#declare l3g0_tech_axle_6 = object { tech_axle scale <1,1,6> }
#declare l3g0_tech_axle_8 = object { tech_axle scale <1,1,8> }
#declare l3g0_tech_axle_10 =object { tech_axle scale <1,1,10> }
#declare l3g0_tech_axle_12 =object { tech_axle scale <1,1,12> }


#declare engrenage_8 =
difference
 {
  union
   {
    cylinder {<0, 0, 0>, <0, 0, wide>, tech_hole_outer_rad}
    #if (Detail_level = 2)
    object {tech_gear_8_teeth translate <0, 0, wide/2>   }
    #end
   }
 object {l3g0_tech_axle_4 translate <0, 0, (-1*wide)> }
 scale 9.7
}

#declare geartube =
    difference
     {
      cylinder {<0, 0, 0>, <0, 0, wide>, (tech_hole_outer_rad+0.05)}
      cylinder {<0, 0, -0.1>, <0, 0, (wide+0.1)>, stud_radius}
     }

#declare engrenage_24 =
difference
 {
  union
   {
    difference
     {
      union
       {
        cylinder {<0, 0, 0>,<0, 0, wide>,tech_hole_outer_rad}
        cylinder {<0, 0, (0.35*wide)>, <0, 0, (0.65*wide)>, (tech_hole_outer_rad+wide) }
        #if (Detail_level = 2)
        object {tech_gear_24_teeth translate <0, 0, 0.4>}
        #end
       }
      object {l3g0_tech_axle_4 translate <0, 0, (-1*wide)>}
     }
    difference
     {
      cylinder {<0, 0, (0.25*wide)>, <0, 0, (0.75*wide)>,(tech_hole_outer_rad+wide)}
      cylinder {<0, 0, 0>, <0, 0, wide>, ((tech_hole_outer_rad+wide)-0.05) }
     }
    object { geartube translate <0.4, 0.4, 0>}
    object { geartube translate <(-1.0*0.4), 0.4, 0> }
    object { geartube translate <0.4, (-1.0*0.4), 0>}
    object { geartube translate <(-1.0*0.4), (-1.0*0.4), 0> }
  }
 union
  {
   object {l3g0_tech_axle_4 rotate <0, 0, 45> translate <(-0.75*wide), 0, (-1*wide)>}
   object {l3g0_tech_axle_4 rotate <0, 0, 45> translate <(0.75*wide), 0, (-1*wide)> }
  }
  scale 9.7
}

#declare tech_gear_tube =  cylinder {<0, 0, 0.1>, <0, 0, 0.7>, 0.32 }
#declare tech_gear_hole =  cylinder {<0, 0, (-0.01)>, <0, 0, (wide+0.01)>,stud_radius }

#if (Detail_level =2)
#declare tech_rackgear_tooth =
intersection
 {
  box {<-.075, 0, (-.5*wide)>, <.075, (wide-(2*tech_hole_outer_rad)), (.5*wide)>}
  sphere {<0, 0, 0>, 1 scale <.075, ((wide-(2*tech_hole_outer_rad))), 1000>}
 }



#declare tech_worm_tooth =
intersection
 {
  box {<-.085, 0, (-.15*wide)>, <.085, (wide-(2*tech_hole_outer_rad)), (.15*wide)>}
  sphere {<0, 0, 0>, 1 scale <.085, ((wide-(2*tech_hole_outer_rad))), 1000>}
 }

#declare tech_gear_16_tooth = object {tech_gear_tooth translate <0, (tech_hole_outer_rad+0.4), 0>}

#declare tech_gear_16_teeth =
union
 {
  #declare number=16
  #declare current=0
  #while (current < 360)
   object { tech_gear_16_tooth rotate <0, 0, current>}
   #declare current = current + (360/number)
  #end
 }
#end

#declare tech_gear_16_cylinder = cylinder {<0, 0, (0.4-.25*wide)>, <0, 0, (0.4+.25*wide)>,stud_radius}
#declare tech_gear_16_hole = cylinder {<0, 0, -1>, <0, 0, (wide)>,(0.32/2)}
#declare tech_gear_16_cylinder_transla = object {tech_gear_16_cylinder translate <0, (.5*wide), 0>}
#declare tech_gear_16_cutout = object {tech_gear_16_hole translate <0, (.5*wide), 0>}


#declare tech_box_cutout =
merge
 {
  box {<-.08, (-.6*wide), -1>, <.08, (.6*wide), 1>}
  box {<(-.6*wide), -.08, -1>, <(.6*wide), .08, 1>}
 }

#declare engrenage_16 =
difference
 {
  union
   {
    difference
     {
      union
       {
        #if (Detail_level = 2)
        object {tech_gear_16_teeth translate <0, 0, 0.4>}
        #end
        cylinder {<0, 0, (0.4-.25*wide)>, <0, 0, (0.4+.25*wide)>, (tech_hole_outer_rad+0.4)}
       }
      union
       {
        cylinder {<0, 0, (0.4-.3*wide)>, <0, 0, (0.4-.1)>, ((tech_hole_outer_rad+0.4)-.1)}
        cylinder {<0, 0, (0.4+.1)>, <0, 0, (0.4+1)>, ((tech_hole_outer_rad+0.4)-.1) }
       }
     }
    object {tech_gear_16_cylinder_transla}
    object {tech_gear_16_cylinder_transla rotate <0, 0, 90>}
    object {tech_gear_16_cylinder_transla rotate <0, 0, 180>}
    object {tech_gear_16_cylinder_transla rotate <0, 0, 270>}
    box {<(-.5*wide+.06), (-.5*wide+.06), 0>, <(.5*wide-.06), (.5*wide-.06), (wide)> rotate <0, 0, 45>}
   }
  union
   {
    object {tech_gear_16_cutout}
    object {tech_gear_16_cutout rotate <0, 0, 90>}
    object {tech_gear_16_cutout rotate <0, 0, 180>}
    object {tech_gear_16_cutout rotate <0, 0, 270>}
    object {tech_box_cutout}
   }
 scale 9.7
 }


#declare engrenage_40 =
difference
 {
  union
   {
    difference
     {
      cylinder {<0, 0, (0.25*wide)>,<0, 0, (0.75*wide)>,(tech_hole_outer_rad+(2*wide))}
      cylinder {<0, 0, 0>, <0, 0, (0.35*wide)>, ((tech_hole_outer_rad+(2*wide))-0.05) }
      cylinder {<0, 0, (0.65*wide)>, <0, 0, (wide)>, ((tech_hole_outer_rad+(2*wide))-0.05)}
     }
    #if (Detail_level=2)
    object {tech_gear_40_teeth translate <0, 0, 0.4>}
    #end
    intersection
     {
      box {<-1.12, -1.12, 0.1>, <1.12, 1.12, 0.7> }
      box {<-1.12, -1.12, 0.0>, <1.12, 1.12, 0.8> rotate <0, 0, 45>}
     }

    box {<-0.06, (-1*(tech_hole_outer_rad+(2*wide))), 0.22>, <0.06, (tech_hole_outer_rad+(2*wide)), 0.58>   rotate <0, 0, 45>  }
    box {<-0.06, (-1*(tech_hole_outer_rad+(2*wide))), 0.22>, <0.06, (tech_hole_outer_rad+(2*wide)), 0.58>   rotate <0, 0, -45>  }

    object {tech_gear_tube translate <(3*0.4), (0.4), 0> }
    object {tech_gear_tube   translate <(3*0.4), (-1*0.4), 0>  }
    object {tech_gear_tube   translate <(-3*0.4), (0.4), 0>  }
    object {tech_gear_tube   translate <(-3*0.4), (-1*0.4), 0>  }
    object {tech_gear_tube   translate <(0.4), (3*0.4), 0>  }
    object {tech_gear_tube   translate <(0.4), (-3*0.4), 0>  }
    object {tech_gear_tube   translate <(-1*0.4), (3*0.4), 0>  }
    object {tech_gear_tube   translate <(-1*0.4), (-3*0.4), 0>  }

    box {   <(-1*0.4), (-1*0.4), 0>, <0.4, 0.4, wide>  }

   }

  object {tech_gear_hole  translate <(-1*0.4), (-3*0.4), 0> }
  object {tech_gear_hole  translate <(1*0.4), (-3*0.4), 0> }
  object {tech_gear_hole  translate <(-3*0.4), (-1*0.4), 0> }
  object {tech_gear_hole  translate <(-1*0.4), (-1*0.4), 0> }
  object {tech_gear_hole  translate <(1*0.4), (-1*0.4), 0> }
  object {tech_gear_hole  translate <(3*0.4), (-1*0.4), 0> }
  object {tech_gear_hole  translate <(-3*0.4), (1*0.4), 0> }
  object {tech_gear_hole  translate <(-1*0.4), (1*0.4), 0> }
  object {tech_gear_hole  translate <(1*0.4), (1*0.4), 0> }
  object {tech_gear_hole  translate <(3*0.4), (1*0.4), 0> }
  object {tech_gear_hole  translate <(-1*0.4), (3*0.4), 0> }
  object {tech_gear_hole  translate <(1*0.4), (3*0.4), 0> }

  object {l3g0_tech_axle_2  translate <0, 0, (-1*0.4)> }
  box {<-0.04, -0.4, 0>, <0.04, 0.4, 1> }
  object {l3g0_tech_axle_2  translate <wide, 0, (-1*0.4)> }
  box {<-0.04, -0.6, 0>, <0.04, 0.6, 1>  translate <(1*wide), 0, 0> }
  object {l3g0_tech_axle_2  translate <(-1*wide), 0, (-1*0.4)> }
  box {<-0.04, -0.6, 0>, <0.04, 0.6, 1>  translate <(-1*wide), 0, 0> }
  object {l3g0_tech_axle_2  translate <0, (wide), (-1*0.4)> }
  box {<-0.6, -0.04, 0>, <0.6, 0.04, 1>  translate <0, (1*wide), 0> }
  object {l3g0_tech_axle_2  translate <0, (-1*wide), (-1*0.4)> }
  box {<-0.6, -0.04, 0>, <0.6, 0.04, 1>  translate <0, (-1*wide), 0> }

 scale 9.7
 }

#if (Detail_level = 2)
#declare tech_worm_tooth_2 = object {tech_worm_tooth}

#declare tech_worm_teeth_section =
union
 {
  #declare number=16
  #declare start=0.02
  #declare current=0
  #while (current < 360)
   object { tech_worm_tooth_2 rotate <0, 0, current> translate <start,0,0>}
   #declare current = current + (360/number)
   #declare start= start + 0.02
  #end

 }


#declare tech_worm_teeth =
union
 {
  object {tech_worm_teeth_section translate <-.32, 0, 0>}
  object {tech_worm_teeth_section }
  object {tech_worm_teeth_section translate <.32, 0, 0>}
  object {tech_worm_teeth_section translate <.64, 0, 0> }
  object {tech_worm_teeth_section translate <.96, 0, 0> }
  object {tech_worm_teeth_section translate <1.28, 0, 0> }
  object {tech_worm_teeth_section translate <1.6, 0, 0> }
 }
#end


#if (Detail_level = 2)
#declare tech_rack_teeth =
union
 {
  object {tech_rackgear_tooth translate <(.5*(4*wide/10)), 0, 0>}
  object {tech_rackgear_tooth translate <(1.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(2.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(3.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(4.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(5.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(6.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(7.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(8.5*(4*wide/10)), 0, 0> }
  object {tech_rackgear_tooth  translate <(9.5*(4*wide/10)), 0, 0> }
 }
#end

#declare cremaillere =
union
 {
  #declare XW=4 #declare YW=flat #declare ZW=1
    difference
   {
    #if (Detail_level = 2)
    superellipsoid
     {
      <.07, .07> // 2x4 "brick"
      scale <wide*XW*0.5, YW*0.5,wide*ZW*0.5>
      translate <wide*XW*0.5,YW*0.5 ,wide*ZW*0.5>
     }
    #else
    box {<0,0,0> <wide*XW,YW, wide*ZW>}
    #end
    box {<wall, -wall, wall>
    <(wide*XW)-wall, YW-wall, (wide*ZW)- wall>}
   }

  #if (Detail_level = 2)
  object {tech_rack_teeth translate <0, .32, (.5*wide)>}
  #end
  #if (Detail_level > 1)
  object { thin_flat_column translate <wide,0,wide*0.5> }
  object { thin_flat_column translate <wide*2,0,wide*0.5> }
  object { thin_flat_column translate <wide*3,0,wide*0.5> }
  #end
 }

#if (Detail_level = 2)
#declare tech_crown_tooth_bottom =
intersection
 {
  object {tech_gear_tooth translate <0, (tech_hole_outer_rad+wide), 0> }
  torus {((tech_hole_outer_rad+wide)-.05), (wide-(2*tech_hole_outer_rad)) rotate <90,0,0> translate <0, 0, (.3*wide)>}
 }


#declare tech_crown_cone =
union
 {
  cylinder {<0, 0, 0>, <0, 0, .05>,.07}
  cone {<0, 0, .05>, .07 <0, 0, .15>, .025 }
  sphere {<0, 0, .15>, .025}
 }

#declare tech_crown_tooth =
merge
 {
  object {tech_crown_tooth_bottom }
  object {tech_crown_cone translate <0, ((tech_hole_outer_rad+wide)+(wide-(2*tech_hole_outer_rad))-.125), (.46*0.4)>}
 }

#declare tech_crown_teeth =
union
 {
  #declare number=24
  #declare current=0
  #while (current < 360)
   object { tech_crown_tooth rotate <0, 0, current> }
   #declare current = current + (360/number)
  #end
 }
#end

#declare tech_gear_crown_shell =
difference
 {
  union
   {
    difference
     {
      union
       {
        #if (Detail_level = 2)
        object { tech_crown_teeth }
        #end
        cylinder {<0, 0, -.05>, <0, 0, (.48*0.4)>, (tech_hole_outer_rad+wide)}
       }
      cylinder {<0, 0, -.5>, <0, 0, .5>, (.8*wide)}
     }
    torus { ((tech_hole_outer_rad+wide)-.15), .1 rotate <90,0,0> translate <0, 0, .01>}
    box {<-.25, (-1*((tech_hole_outer_rad+wide)-.2)), -.05>, <.25, ((tech_hole_outer_rad+wide)-.2), (.48*0.4)>}
    cone {<0, 0, -.05>, (wide/2) <0, 0, -.09>, (wide/2-.05) }
    cylinder {<0, 0, -.05>, <0, 0, .66>, (wide/2) open}
    cone {<0, 0, .66>, (wide/2) <0, 0, .71>, (wide/2-.05)}
   }
  object {l3g0_tech_axle_3 translate <0, 0, (-1*wide)> }
  box {<-.045, (-1*(.8*wide-.1)), -1>, <.045, (.8*wide-.1), 1>}
 }

#declare engrenage_24_perpendiculaire= object {tech_gear_crown_shell scale 9.7 translate <0, 0, .09> }


#declare petites_dents=intersection{ union {
                             #declare Count=0
                             #while (Count <= 16)
                              box {0.26*e3-0.0325*e2+0.1*e1 0.39*e3+0.0325*e2 pigment { color Gray80} rotate <22.5*Count,0,0>}

                              #declare Count=Count+1
                             #end }
                        cylinder {<0,0,0> e1 3.5 pigment {color Gray80} }

                           }

#declare petite_bague=difference {union {cylinder { <0,0,0> 0.38*e1 2.5 pigment { Gray80 }}
                                                       cylinder {<0,0,0> 0.12*e1 3.5 pigment {Gray80}}
                                                       cylinder {0.38*e1 (0.29)*e1 3.5 pigment {Gray80}}
                                                       object {petites_dents translate 0.38*e1 }
                                              }
                                              object {tige_4}
                                 }

#declare embout_tuyau=difference {superellipsoid {<1,0.2> rotate <0,90,0> scale <5,1.5,1.5>}
                                  union {
                                  box{ <-1,10,-10> <-10,-10,10> }
                                  cylinder{ <10,0,0> <-10,0,0> 0.5 }
                                        }
                                 }

#declare base_piston=difference {union{ superellipsoid { <0.01, 0.01> pigment {color lego_yellow} scale e1+e2+0.5*e3 translate 0.5*e3}
                               cylinder {e3 5*e3 vlength(0.9*e1) pigment {color lego_yellow}}
                               cylinder {4*e3 5*e3 vlength(e1) pigment {color lego_yellow}}
                               cylinder {5*e3 5.05*e3 vlength(0.55*e1) pigment {color lego_yellow}}
                               object {embout_tuyau pigment {lego_yellow} translate e1+0.5*e3}
                                }

                                    union {
                                          object{ trou_tige pigment{color lego_yellow } translate -e1 }
                                          object{ trou_tige pigment{color lego_yellow } translate -e1-e2 }
                                   }}
#declare piston_ressort=difference{union{ object {base_piston}
                               object {tige_6 rotate <0,0,90> translate 4*e3 scale <1.5,1,1.5> }
                               #declare Count=0
                               #while (Count <= 10)
                                 torus { 3.8 0.3 translate <0,50,0>+<0,3,0>*Count texture{Aluminum}}
                                 #declare Count=Count+1
                               #end

                               difference {
                               superellipsoid {<1,0.1> rotate <90,0,0> scale (0.5*e3+e1+e2) translate 8.5*e3 texture{lego_black}}
                               union {
                                      sphere {15*e3 vlength(5.6*e3) texture {lego_black} }
                                      cylinder {8.4*e3+2*e2 8.9*e3-2*e2 2.5 texture {lego_black} }
                                     } } }
                                    cylinder {0.95*e1+4.6*e3, 2*e1+4.6*e3, 2 pigment{color lego_yellow}}
                                    cylinder {-0.95*e1+4.6*e3, -2*e1+4.6*e3, 2 pigment{color lego_yellow}}
                               translate e1+e2
                                  }

#declare grand_piston=difference{union{ object {base_piston}
                                        object {embout_tuyau pigment {lego_yellow} translate e1+4.5*e3}
                                        cylinder {e3 7.6*e3 2.5 texture {Aluminum} }
                                        cylinder {7.6*e3 8.1*e3 2.5 texture {lego_black} }
                                        cylinder {8*e3 8.4*e3 3.5 texture {lego_black} }
                                        cylinder {8.5*e3-0.5*e2 8.5*e3+0.5*e2 4 texture {lego_black} }
                                      }
                                    cylinder {0.95*e2+4.6*e3, 2*e2+4.6*e3, 2 pigment{color lego_yellow}}
                                    cylinder {-0.95*e2+4.6*e3, -2*e2+4.6*e3, 2 pigment{color lego_yellow}}
                                    object{ trou_tige texture{ lego_black} translate -e1+7.9*e3-0.5*e2 }
                                  translate e1+e2}

#declare grand_piston_75=difference{union{ object {base_piston}
                                        object {embout_tuyau pigment {lego_yellow} translate e1+4.5*e3}
                                        cylinder {e3 7.1*e3 2.5 texture {Aluminum} }
                                        cylinder {6.1*e3 6.6*e3 2.5 texture {lego_black} }
                                        cylinder {6.5*e3 6.9*e3 3.5 texture {lego_black} }
                                        cylinder {6.9*e3-0.5*e2 6.9*e3+0.5*e2 4 texture {lego_black} }
                                      }
                                    cylinder {0.95*e2+4.6*e3, 2*e2+4.6*e3, 2 pigment{color lego_yellow}}
                                    cylinder {-0.95*e2+4.6*e3, -2*e2+4.6*e3, 2 pigment{color lego_yellow}}
                                    object{ trou_tige texture{ lego_black} translate -e1+6.4*e3-0.5*e2 }
                                  translate e1+e2}

#declare barre_1x1=union {
object {teton_normal}
superellipsoid { <0.05,0.05> scale 0.5*(e1+e2+e3) translate 0.5*(e1+e2+e3)  }
}

#declare barre_2x1=union {
object {teton_normal}
object {teton_normal translate e1}
superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
}

#declare barre_3x1=union {
object {teton_normal}
object {teton_normal translate e1}
object {teton_normal translate 2*e1}
superellipsoid { <0.05,0.05> scale 0.5*(3*e1+e2+e3) translate 0.5*(3*e1+e2+e3)  }
}
#declare barre_4x1=union {
object {teton_normal}
object {teton_normal translate e1}
object {teton_normal translate 2*e1}
object {teton_normal translate 3*e1}
superellipsoid { <0.05,0.05> scale 0.5*(4*e1+e2+e3) translate 0.5*(4*e1+e2+e3)  }
}

#declare barre_2x1=union {
object {teton_normal}
object {teton_normal translate e1}
superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+e3) translate 0.5*(2*e1+e2+e3)  }
}

#declare tenon_tige=union {difference {object{ tenon_blanc}
                                       box {1.1*e1-e2-e3 3*e1+e2+e3 pigment {color Gray90}}
                                      }
                                      cylinder{ 0.9*e1,1.1*e1,3 texture {pigment{color Gray90 }}}
                                      union {superellipsoid { <0.05, 0.05> scale 0.7*e1+<0,2.3,0.8> translate 1.3*e1 }
                                             superellipsoid { <0.05, 0.05> scale 0.7*e1+<0,2.3,0.8> translate 1.3*e1 rotate 90*x}
                                             pigment {color Gray90 }
                                            } }

#declare perpendiculaire_1=difference{union { object{ bague rotate <0,180,0> translate e1}
                                   cylinder { 0.9*e1,1.5*e1,3.5 pigment {color Gray90}}
                                   cylinder { 1.5*e1-0.5*e2,1.5*e1+0.5*e2,3.5 pigment {color Gray90}}
                                 }
                                 object{ tige_3 scale <1,1.1,1.1> rotate <0,-90,0> translate -2*e2+1.5*e1}
                                 }
#declare plaque_trou_3x1=difference {union {box {0.5*e1 2.5*e1+e2+1/3*e3 }
                                     cylinder { 0.5*(e1+e2) 0.5*(e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     cylinder { 0.5*(5*e1+e2) 0.5*(5*e1+e2)+1/3*e3 1/2*vlength(e1)}
                                           }
                                     union {cylinder {0.5*(3*e1+e2)-e3 0.5*(3*e1+e2)+e3 2.5 }
                                            object{ tige_2 texture{ pigment{ color Red} }scale <1,1.2,1.2> rotate <0,0,90> translate 0.5*(e2+e1)-1/2*e3 }
                                            object{ tige_2 texture{ pigment{ color Red} }scale <1,1.2,1.2> rotate <0,0,90> translate 0.5*(e2+5*e1)-1/2*e3 }
                                           }
                                    }
#declare plaque_trou_8x1=difference {union {box {0.5*e1 7.5*e1+e2+1/3*e3 }
                                     cylinder { 0.5*(e1+e2) 0.5*(e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     cylinder { 0.5*(15*e1+e2) 0.5*(15*e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     object{petites_dents rotate <0,0,-90> translate 0.5*(e1+e2)}
                                     object{petites_dents rotate <0,0,-90> translate 0.5*(15*e1+e2)}
                                     #declare Count=0
                                     #while (Count<6)
                                      object{teton translate -2/3*e3+(Count+1)*e1}
                                      #declare Count=Count+1
                                     #end
                                           }
                                     union {cylinder {0.5*(e1+e2)-e3 0.5*(e1+e2)+e3 2.5 }
                                            cylinder {0.5*(15*e1+e2)-e3 0.5*(15*e1+e2)+e3 2.5 }
                                           }

                                    }
#declare branche=difference {union {box {0.5*e1 2.5*e1+e2+1/3*e3 }
                                     cylinder { 0.5*(e1+e2) 0.5*(e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     cylinder { 0.5*(5*e1+e2) 0.5*(5*e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     object{petites_dents rotate <0,0,-90> translate 0.5*(e1+e2)}
                                      object{teton translate -2/3*e3+e1}
                                           }
                                           cylinder {0.5*(5*e1+e2)-e3 0.5*(5*e1+e2)+e3 2.5 }
                                           translate -0.5*(e1+e2)
                                    }

#declare croix_3=difference {union {object {branche}
                             object {branche rotate <0,120,0> }
                             object {branche rotate <0,-120,0>}
                                   }
                             object {tige_4 rotate <0,0,90> translate -e3 } }

 #declare plaque_trou_6x1=union {difference {union {box {0.5*e1 5.5*e1+e2+1/3*e3 }
                                     cylinder { 0.5*(e1+e2) 0.5*(e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     cylinder { 0.5*(11*e1+e2) 0.5*(11*e1+e2)+1/3*e3 1/2*vlength(e1)}
                                     object{petites_dents rotate <0,0,-90> translate 0.5*(e1+e2)}
                                     object{petites_dents rotate <0,0,-90> translate 0.5*(11*e1+e2)}
                                     #declare Count=0
                                     #while (Count<4)
                                      object{teton translate -2/3*e3+(Count+1)*e1}
                                      #declare Count=Count+1
                                     #end
                                           }
                                     union {cylinder {0.5*(e1+e2)-e3 0.5*(e1+e2)+e3 2.5 }
                                            box { 1.1*e1+0.15*e2-e3 4.9*e1+0.85*e2+0.2*e3 }
                                            cylinder {0.5*(11*e1+e2)-e3 0.5*(11*e1+e2)+e3 2.5 }
                                           }
                                           }
                                     cylinder { 0.5*(3*e1+e2) 0.5*(3*e1+e2)+0.25*e3 1.5 }
                                     cylinder { 0.5*(5*e1+e2) 0.5*(5*e1+e2)+0.25*e3 1.5 }
                                     cylinder { 0.5*(7*e1+e2) 0.5*(7*e1+e2)+0.25*e3 1.5 }
                                     cylinder { 0.5*(9*e1+e2) 0.5*(9*e1+e2)+0.25*e3 1.5 }
}

#declare moteur=difference {union {superellipsoid { <0.01,0.01> scale 0.5*(5*e1+4*e2+1/3*e3) translate 0.5*(5*e1+4*e2+1/3*e3) pigment {color <0.68,0.54,0.5>} }
                       superellipsoid { <0.01,0.01> scale 0.5*(5*e1+4*e2+2*e3) translate 0.5*(5*e1+4*e2+7/3*e3) pigment {color Gray80} }
                       object {tige_2 translate 2*e2+(2/3+0.6)*e3+4*e1}
                       #declare Count=0
                       #while (Count<5)
                        #declare Count=Count+1
                        object {teton_normal pigment {color Gray80} translate 0.1*e2+(Count-1)*e1+1.1*e3 }
                       #end
                       #declare Count=0
                       #while (Count<5)
                        #declare Count=Count+1
                        object {teton_normal pigment {color Gray80} translate 1.1*e2+(Count-1)*e1+1.1*e3 }
                       #end
                       #declare Count=0
                       #while (Count<5)
                        #declare Count=Count+1
                        object {teton_normal pigment {color Gray80} translate 2.1*e2+(Count-1)*e1+1.1*e3 }
                       #end
                       #declare Count=0
                       #while (Count<5)
                        #declare Count=Count+1
                        object {teton_normal pigment {color Gray80} translate 3.1*e2+(Count-1)*e1+1.1*e3 }
                       #end
                                  }
                            union { box{-e1+(1/3+0.20)*e3+5*e2 6*e1+(1/3+0.49)*e3+3.85*e2 pigment {color Gray80}}
                                    box{-e1+(1/3+0.77)*e3+5*e2 6*e1+(1/3+1.05)*e3+3.85*e2 pigment {color Gray80}}
                                    box{-e1+(1/3+1.33)*e3+5*e2 6*e1+(1/3+1.61)*e3+3.85*e2 pigment {color Gray80}}
                                    box{-e1+(1/3+0.20)*e3-e2 6*e1+(1/3+0.49)*e3+0.15*e2 pigment {color Gray80}}
                                    box{-e1+(1/3+0.77)*e3-e2 6*e1+(1/3+1.05)*e3+0.15*e2 pigment {color Gray80}}
                                    box{-e1+(1/3+1.33)*e3-e2 6*e1+(1/3+1.61)*e3+0.15*e2 pigment {color Gray80}}
                                  }
                           }

#declare petit_piston=difference {union { cylinder {<0,0,0> e1 3.6 pigment {color lego_yellow}}
                              cylinder {0.5*e1 0.5*e1+6/3*e3 3.5 pigment {color lego_yellow}}
                              object {tige_4 rotate <0,0,90> translate 0.5*(e3+e1) }
                              cylinder {<0,0,0>+4*e3 e1+4*e3 3.6 texture {lego_black}}
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+0.3*e3 }
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+1.8*e3 }
                                        }
                                  union { object{ trou_tige pigment {color lego_yellow } translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)}
                                         object{ trou_tige texture {lego_black} translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)+<0,5*vlength(e1),0>}
                                        }
                                 }

#declare petit_piston_4=difference {union { cylinder {<0,0,0> e1 3.6 pigment {color lego_yellow}}
                              cylinder {0.5*e1 0.5*e1+6/3*e3 3.5 pigment {color lego_yellow}}
                              object {tige_2 rotate <0,0,90> translate 0.5*(e3+e1) }
                              cylinder {<0,0,0>+2.5*e3 e1+2.5*e3 3.6 texture {lego_black}}
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+0.3*e3 }
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+1.8*e3 }
                                        }
                                  union { object{ trou_tige pigment {color lego_yellow } translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)}
                                         object{ trou_tige texture {lego_black} translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)+<0,3*vlength(e1),0>}
                                        }
                                 }

#declare petit_piston_45=difference {union { cylinder {<0,0,0> e1 3.6 pigment {color lego_yellow}}
                              cylinder {0.5*e1 0.5*e1+6/3*e3 3.5 pigment {color lego_yellow}}
                              object {tige_3 rotate <0,0,90> translate 0.5*(2*e3+e1) }
                              cylinder {<0,0,0>+3.5*e3 e1+3.5*e3 3.6 texture {lego_black}}
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+0.3*e3 }
                              object{ embout_tuyau pigment {color lego_yellow} rotate <0,-90,0> translate 0.5*(e1+0.8*e2)+1.8*e3 }
                                        }
                                  union { object{ trou_tige pigment {color lego_yellow } translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)}
                                         object{ trou_tige texture {lego_black} translate -0.6*e3-0.5*(e1+e2) rotate <0,-90,0> translate 0.5*(e1-e2)+<0,4.5*vlength(e1),0>}
                                        }
                                 }

#declare dent_biseau=difference { box { -0.71*e3-0.06*e1, -0.37*e3+0.06*e1+0.2*e2 pigment{ color Gray80} }
                                  box {-e1-e2-e3 e1+e2+e3 rotate <45,0,0> translate -e3+1.15*e2 pigment {color Gray80}}
                                }

#declare engrenage_16_biseaute=difference {union { #declare Count=0
                                       #while(Count <14)
                                       object {dent_biseau rotate <0,0,360/14*Count>}
                                       #declare Count=Count+1
                                       #end
                                       cylinder { -0.1*e2 0 0.48*vlength(e3) pigment { color Gray80 }}
                                       cone { 0,0.6*vlength(e3),0.2*e2,0.4*vlength(e3) pigment {color Gray80}}
                                     }
                                       object {tige_4 rotate <0,90,0> translate 3*e2 pigment { color Gray80}}
                                       cylinder { -e2 0 0.36*vlength(e3) pigment { color Gray80 }}
                                     }

#declare barre_trou_4=difference {union {difference{union { cylinder { 0, <0, vlength(e1), 0>, 0.5*vlength(e1) pigment {color Gray80 } }
                                  cylinder { 3*e2, 3*e2+<0, 0.5*vlength(e1), 0>, 0.5*vlength(e1)  pigment {color Gray80 } }
                                  difference {
                                              box {-0.5*e1 <0,0.5*vlength(e1),0>+0.5*e1+3*e2 pigment {color Gray80 }}
                                              union {
                                                    box {-e3-0.4*e1 1.2*e2+e3+0.4*e1 pigment {color Gray80 } }
                                                    box {1.7*e2-e3-0.4*e1 3*e2+e3+0.4*e1 pigment {color Gray80 } }
                                                    box {-0.4*e1 <0,0.1*vlength(e1),0>+0.4*e1+3*e2 pigment {color Gray80 }}
                                                    box {-0.4*e1+<0,0.4*vlength(e1),0> <0,0.6*vlength(e1),0>+0.4*e1+3*e2 pigment {color Gray80 }}
                                                    }}}
                                union {
                                       box {-0.16*e1-e3 0.16*e1+e2+<0,0.5*vlength(e1),0> pigment {color Gray80 }}
                                       box {-0.16*e1-e3+3*e2 0.16*e1+2*e2+e3 pigment {color Gray80 }}
                                       object{ tige_4 scale 1.2 rotate <0,0,90> translate -2*e3 pigment {color Gray80 }}
                                       object{ tige_4 scale 1.2 rotate <0,0,90> translate -2*e3+3*e2 pigment {color Gray80 }}
                                      }}
                             union { cylinder { e2, e2+<0, 0.5*vlength(e1), 0>, 0.45*vlength(e1) pigment {color Gray80 } }
                                     cylinder { 2*e2, 2*e2+<0, 0.5*vlength(e1), 0>, 0.45*vlength(e1) pigment {color Gray80 } }
                                   }}
                             union { cylinder { e2-e3, e2+<0, 0.1*vlength(e1), 0>, 0.4*vlength(e1) pigment {color Gray80 } }
                                     cylinder { 2*e2+<0, 0.4*vlength(e1),0> 2*e2+<0, 0.6*vlength(e1), 0>, 0.4*vlength(e1) pigment {color Gray80 } }
                                     cylinder { e2+<0, 0.4*vlength(e1),0> e2+<0, 0.6*vlength(e1), 0>, 0.4*vlength(e1) pigment {color Gray80 } }
                                     cylinder { 2*e2-<0, 0.1*vlength(e1),0> 2*e2+<0, 0.1*vlength(e1), 0>, 0.4*vlength(e1) pigment {color Gray80 } }
                                     cylinder { e2, e2+<0, 0.5*vlength(e1), 0>, 0.3*vlength(e1) pigment {color Gray80 } }
                                     cylinder { 2*e2, 2*e2+<0, 0.5*vlength(e1), 0>, 0.3*vlength(e1) pigment {color Gray80 } }
                                     cylinder { e3+1/2*(e1+e2), <0, 0.5*vlength(e1), 0>+1/2*(e1+e2), 2.4 pigment {color Gray80 }}
                                     cylinder { e3+1/2*(e1-e2), <0, 0.5*vlength(e1), 0>+1/2*(e1-e2), 2.4 pigment {color Gray80 }}
                                     cylinder { e3-1/2*(e1-e2), <0, 0.5*vlength(e1), 0>-1/2*(e1-e2), 2.4 pigment {color Gray80 }}
                                     cylinder { e3-1/2*(e1+e2), <0, 0.5*vlength(e1), 0>-1/2*(e1+e2), 2.4 pigment {color Gray80 }}
                                     cylinder { <0,0.5*vlength(e1),0>, e3, 0.32*vlength(e1) pigment {color Gray80 } }
                                     }
                            }

#declare barre_trou_4_jaune=difference {union {difference{union { cylinder { 0, <0, vlength(e1), 0>, 0.5*vlength(e1) pigment {color lego_yellow } }
                                  cylinder { 3*e2, 3*e2+<0, 0.5*vlength(e1), 0>, 0.5*vlength(e1)  pigment {color lego_yellow } }
                                  difference {
                                              box {-0.5*e1 <0,0.5*vlength(e1),0>+0.5*e1+3*e2 pigment {color lego_yellow }}
                                              union {
                                                    box {-e3-0.4*e1 1.2*e2+e3+0.4*e1 pigment {color lego_yellow } }
                                                    box {1.7*e2-e3-0.4*e1 3*e2+e3+0.4*e1 pigment {color lego_yellow } }
                                                    box {-0.4*e1 <0,0.1*vlength(e1),0>+0.4*e1+3*e2 pigment {color lego_yellow }}
                                                    box {-0.4*e1+<0,0.4*vlength(e1),0> <0,0.6*vlength(e1),0>+0.4*e1+3*e2 pigment {color lego_yellow }}
                                                    }}}
                                union {
                                       box {-0.16*e1-e3 0.16*e1+e2+<0,0.5*vlength(e1),0> pigment {color lego_yellow }}
                                       box {-0.16*e1-e3+3*e2 0.16*e1+2*e2+e3 pigment {color lego_yellow }}
                                       object{ tige_4 scale 1.2 rotate <0,0,90> translate -2*e3 pigment {color lego_yellow }}
                                       object{ tige_4 scale 1.2 rotate <0,0,90> translate -2*e3+3*e2 pigment {color lego_yellow }}
                                      }}
                             union { cylinder { e2, e2+<0, 0.5*vlength(e1), 0>, 0.45*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { 2*e2, 2*e2+<0, 0.5*vlength(e1), 0>, 0.45*vlength(e1) pigment {color lego_yellow } }
                                   }}
                             union { cylinder { e2-e3, e2+<0, 0.1*vlength(e1), 0>, 0.4*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { 2*e2+<0, 0.4*vlength(e1),0> 2*e2+<0, 0.6*vlength(e1), 0>, 0.4*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { e2+<0, 0.4*vlength(e1),0> e2+<0, 0.6*vlength(e1), 0>, 0.4*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { 2*e2-<0, 0.1*vlength(e1),0> 2*e2+<0, 0.1*vlength(e1), 0>, 0.4*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { e2, e2+<0, 0.5*vlength(e1), 0>, 0.3*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { 2*e2, 2*e2+<0, 0.5*vlength(e1), 0>, 0.3*vlength(e1) pigment {color lego_yellow } }
                                     cylinder { e3+1/2*(e1+e2), <0, 0.5*vlength(e1), 0>+1/2*(e1+e2), 2.4 pigment {color lego_yellow }}
                                     cylinder { e3+1/2*(e1-e2), <0, 0.5*vlength(e1), 0>+1/2*(e1-e2), 2.4 pigment {color lego_yellow }}
                                     cylinder { e3-1/2*(e1-e2), <0, 0.5*vlength(e1), 0>-1/2*(e1-e2), 2.4 pigment {color lego_yellow }}
                                     cylinder { e3-1/2*(e1+e2), <0, 0.5*vlength(e1), 0>-1/2*(e1+e2), 2.4 pigment {color lego_yellow }}
                                     cylinder { <0,0.5*vlength(e1),0>, e3, 0.32*vlength(e1) pigment {color lego_yellow } }
                                     }
                            }

#declare raccord_barre=difference {union {cylinder {0,2*e1,3.5 pigment {color Gray80 } }
                                          cylinder {0.48*e1 0.52*e1 3.7 pigment {color Gray80 } }
                                          cylinder {0.98*e1 1.02*e1 3.7 pigment {color Gray80 }}
                                          cylinder {1.48*e1 1.52*e1 3.7 pigment {color Gray80 }}
                                         }
                                  union {object {tige_4 translate -e1 }
          cylinder {1/2*(e2+e3)-e1,3*e1+1/2*(e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(-e2+e3)-e1,3*e1+1/2*(-e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(-e2-e3)-e1,3*e1-1/2*(e2+e3),3 texture {pigment{color Gray90}}}
          cylinder {1/2*(e2-e3)-e1,3*e1+1/2*(e2-e3),3 texture {pigment{color Gray90}}}
                                         }}

#declare commutateur_air=union {difference {union {superellipsoid { <0.05,0.05> scale 0.5*(2*e1+e2+(2+1/3)*e3) translate 0.5*(2*e1+e2+(2+1/3)*e3) pigment {color Gray80} }
                                object {embout_tuyau pigment {color Gray80} rotate <0,-90,0> translate 0.8*e3+1.1*e1+0.8*e2}
                                object {embout_tuyau pigment {color Gray80} rotate <0,-90,0> translate 1.2*e3+0.65*e1+0.8*e2}
                                object {embout_tuyau pigment {color Gray80} rotate <0,-90,0> translate 1.8*e3+1.1*e1+0.8*e2}
                                object { teton pigment {color Gray80 } translate (4/3-0.07)*e3 }
                                object { teton pigment {color Gray80 } translate (4/3-0.07)*e3+e1 }
                                           }
                                     box { 0.1*e2+0.6*e3+e1 0.9*e2+1.8*e3+3*e1 pigment {color Gray80}}
                                     }
                                object { tige_2 translate 0.5*e2+7/6*e3+1.1*e1 }
                                cylinder { 0.05*e2+e1+7/6*e3 0.95*e2+e1+7/6*e3 0.6*vlength(e3) pigment {color Black } }
                                    }
#declare perpendiculaire_2=difference {union { cylinder { <-1/2*vlength(e3),0,0> <0.5*vlength(e3),0,0> 1/2*vlength(e3) pigment {color Gray80}}
                                               cylinder { <0,-1/2*vlength(e3),0>+e2, e2+<0,0.5*vlength(e3),0> 1/2*vlength(e3) pigment {color Gray80}}
                                               box { <1/2*vlength(e3),1/2*vlength(e3),0>, <-1/2*vlength(e3),-1/2*vlength(e3),0>+e2 pigment {color Gray80 }}
                                             }
                                       union { cylinder {-e1 2*e1 3 pigment {color Gray80 } }
                                               object {tige_3 rotate <0,0,90> translate e2-1.5*e3 pigment {color Gray80 } scale 1.2}
                                             }
                                      }
#declare interieure_roue_1=difference {union {difference { cylinder { 0, e1, 8.5 pigment {lego_yellow }}
                                    cylinder {-e1 2*e1 6 pigment {lego_yellow }}
                                  }
                       cylinder {-0.05*e1 1.05*e1 3.5 pigment {color lego_yellow }}
                       box { -e2-0.1*e3 e2+e1+0.1*e3 pigment {color lego_yellow }}
                      }    union {
                            object {tige_3 translate -e1 scale 1.1 pigment {color lego_yellow }}
                            box { -e1-0.1*e2-0.6*e3 2*e1+0.1*e2+0.6*e3 pigment {color lego_yellow } }
                            }
                           }
#declare dents_roue_1=union { #declare Count=1
                           #while (Count < 23)
                            #declare Count=Count+1
                            box {<-10,10,-0.75> <0.5*vlength(e1),15,0.75> texture {lego_black } rotate <360/22*Count,0,0>}
                           #end
                            #declare Count=1
                           #while (Count < 23)
                            #declare Count=Count+1
                            box {<0.5*vlength(e1),10,-0.75> <2*vlength(e1),15,0.75> texture {lego_black } rotate <360/22*(Count+0.5),0,0>}
                           #end
 }

#declare roue_1=union { object { interieure_roue_1 }
                        difference { cylinder {0 e1 12 texture {lego_black}}
                                     union {
                                     cylinder {-e1 2*e1 9 texture {lego_black }}
                                     object {dents_roue_1}
                                     }
}}

